package anywheresoftware.mago.b4j.jxfunctionWin32;

import com.excelsior.xFunction.*;

import anywheresoftware.b4a.BA.Author;
import anywheresoftware.b4a.BA.DependsOn;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;


/* 
 * La libreria xFunction, disponibile sia per Windows che per Linus,
 * risulta una libreria molto comoda da utilizzare per le chiamate alle API native. 
 *
 * Qui si utilizza la libreria per Windows. 
 * 
 * Per poter utilizzare xFunction e' necessario avere una copia di xFunction.jar nella cartella delle librerie aggiuntive 
 * e una copia della xFunction.dll nella cartella oggetti o nel classpath di Java. 
 *
 */
@DependsOn(values = { "xFunction" })
@Author("Maurizio Agosti")
@Version(1.0f)
@ShortName("xFunctionWin32")
public class xFunctionWin32 {
 
	/* *
	 * The xFunction library allows you to call external functions, implemented in any language and residing in DLLs
	 * or shared libraries, from your Java program. With xFunction, you do not need to implement native methods operating
	 * through Java Native Interface (JNI). Instead, you extend and instantiate xFunction classes to create conventional
	 * Java objects representing external functions, data structures, pointers, and callbacks. All necessary data conversions
	 * and external function calls are done seamlessly by the xFunction library.
	 *
	 * xFunction is a product ofExcelsior, LLC http://www.excelsior-usa.com and has been placed in the public domain.
	 * It may be downloaded from http://www.excelsior-usa.com/xfunctiondl.html, taking note of the conditions of use.
	 *
	 * It is not really practical to add new API calls from within B4J code so the source of this library is included in the
	 * library archive so you can modify yourself and compile it with Eclipse or the Simple Library Compiler.
	 */
	public void LIBRARY_DOC() {
	}
	
	// API call definitions, saved so only called once for efficiency
	xFunction iGetTickCount;
	xFunction iGetLastInputInfo;

	
	/*
	 * Initializes the API call functions.
	 *
	 * If you are writing your own function definitions note that the function parameter type efinition requires 
	 * the fully qualified name, as used for Class.forName() except for the following
	 * "void", "byte", "char", "short", "int", "long", "float", "double", "CSTRING", "UNICODESTRING" and "BSTR".
	 */
	public void Initialize() throws Exception {
		iGetTickCount = new xFunction("kernel32", "int GetTickCount()");
		iGetLastInputInfo = new xFunction("User32", "int GetLastInputInfo(anywheresoftware.mago.b4j.jxfunctionWin32.LASTINPUTINFO*)");
		
	}	
	

	/*
	 * Retrieves the number of milliseconds that have elapsed since the system was started, up to 49.7 days.
	 *
	 */
	public int GetTickCount() throws Exception  {
		Integer r = (Integer) iGetTickCount.invoke();
		return r;
	}



	/*
	 * Return Tick count of when the last input event was received
	 */
	public int GetLastInputInfo() throws Exception { 
		LASTINPUTINFO info = new LASTINPUTINFO();
		info.cbSize = 8;
        	Pointer arg = Pointer.createPointerTo(info);
        	iGetLastInputInfo.invoke(arg);
        	info = (LASTINPUTINFO)arg.deref();
        	return info.dwTime;
	}

}	
	
	
class LASTINPUTINFO extends Structure {
	int cbSize;
        int dwTime;
	
	public String defineLayout() { 
		return "int cbSize, int dwTime";
	}
	public LASTINPUTINFO() {}

}

	

